package com.orange.documentare.core.comp.bwt;
/*
 * Copyright (c) 2020 Orange
 *
 * Authors: Denis Boisset, Christophe Maldivi & Joel Gardes
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 */

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.Arguments;
import org.junit.jupiter.params.provider.MethodSource;

import java.util.stream.Stream;

import static org.assertj.core.api.BDDAssertions.then;
import static org.junit.jupiter.params.provider.Arguments.of;

public class BwtFunctionnalTest {

  static final String TEST_STRING_0 = "edcba";
  static final String EXPECTED_STRING_0 = "bcdea";

  static final String TEST_STRING_1 = "^BANANA|";
  static final String EXPECTED_STRING_1 = "BNN^AA|A";

  static final String TEST_STRING_2 = "SIX.MIXED.PIXIES.SIFT.SIXTY.PIXIE.DUST.BOXES";
  static final String EXPECTED_STRING_2 = "TEXYDST.E.IXIXIXXSSMPPS.B..E.S.EUSFXDIIOIIIT";

  static final String TEST_STRING_3 = "ababc#";
  static final String EXPECTED_STRING_3 = "c#baab";

  static final String TEST_STRING_4 = "abracadabra";
  static final String EXPECTED_STRING_4 = "rdarcaaaabb";

  static final String TEST_STRING_5 = "this is a test.";
  static final String EXPECTED_STRING_5 = "ssat tt hiies .";

  static final String TEST_STRING_6 = "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim ids est laborum.";
  static final String EXPECTED_STRING_6 = "...mratttsea,ontademmtxogttseepdumtrtrmetotedtststtiana,n,rr,dnitemntmtttram  . neilpulll  cm  il  pctiudtti aaaceoxin srm   e  euaoiin iao     iisrrrtrt assr v rthv drcsxdsd   mt t  of nuaeuscngrfpoc dcnnn    cmstud ll urupnsllrlcel   laaleeuuoioooouloiuuieiau aa osm eioioigieieeai   oouuiue ddc mm rmddddvcnicclplbllLbbnil uime iueie i uoououeuooopo aoeptoeiidiiisn nei  ueeop uiiaeUiniusnaanneinaapiua cpaseaeqqrfqqDqn cslrsrdcltetri  a   eEe";

  static final String TEST_STRING_7 = "textueltextuel";
  static final String EXPECTED_STRING_7 = "uutteellxxttee";

  static final byte[] BYTES_LONG = {
    (byte) 0xac, (byte) 0xff, (byte) 0x24, (byte) 0x34, (byte) 0x7f, (byte) 0xce, (byte) 0x3f, (byte) 0x9a, (byte) 0x50, (byte) 0x70, (byte) 0x67, (byte) 0x04, (byte) 0x2f, (byte) 0xb6, (byte) 0xae, (byte) 0xce, (byte) 0xd1, (byte) 0x61, (byte) 0x35, (byte) 0x34, (byte) 0xc9, (byte) 0x57, (byte) 0x88, (byte) 0x14, (byte) 0x05, (byte) 0xc1, (byte) 0x79, (byte) 0x85, (byte) 0x11, (byte) 0xda, (byte) 0xe2, (byte) 0x11, (byte) 0x90, (byte) 0xfe, (byte) 0x6f, (byte) 0x30, (byte) 0x71, (byte) 0x85, (byte) 0xba, (byte) 0xf7, (byte) 0xe8, (byte) 0x2a, (byte) 0x25, (byte) 0x03, (byte) 0xc3, (byte) 0x16, (byte) 0x2e, (byte) 0x87, (byte) 0xeb, (byte) 0x25, (byte) 0xfe, (byte) 0xa5, (byte) 0x42, (byte) 0x88, (byte) 0x0d, (byte) 0x95, (byte) 0xb2, (byte) 0xc0, (byte) 0xb0, (byte) 0xc8, (byte) 0x44, (byte) 0x64, (byte) 0x5e, (byte) 0xd1, (byte) 0xc1, (byte) 0xf6, (byte) 0x22, (byte) 0x15, (byte) 0xf9, (byte) 0x1d, (byte) 0x84, (byte) 0x39, (byte) 0xb8, (byte) 0xd3, (byte) 0x1c, (byte) 0xf7, (byte) 0x17, (byte) 0xc3, (byte) 0x55, (byte) 0x87, (byte) 0x14, (byte) 0x62, (byte) 0x29, (byte) 0x35, (byte) 0xb9, (byte) 0x3b, (byte) 0x4b, (byte) 0x83, (byte) 0x13, (byte) 0x29, (byte) 0x3e, (byte) 0x90, (byte) 0xed, (byte) 0xe3, (byte) 0x6e, (byte) 0x5e, (byte) 0x72, (byte) 0xd2, (byte) 0x70, (byte) 0x90, (byte) 0xeb, (byte) 0xe1, (byte) 0x9f, (byte) 0x40, (byte) 0x0f, (byte) 0x4c, (byte) 0xe4, (byte) 0xf1, (byte) 0x2d, (byte) 0x83, (byte) 0xfc, (byte) 0x8c, (byte) 0x6f, (byte) 0xbc, (byte) 0xb6, (byte) 0x1a, (byte) 0x61, (byte) 0x93, (byte) 0x5e, (byte) 0xe0, (byte) 0xfa, (byte) 0x15, (byte) 0x8b, (byte) 0xb2, (byte) 0x7a, (byte) 0xcc, (byte) 0x00, (byte) 0x75, (byte) 0x5f, (byte) 0x7d, (byte) 0x7c, (byte) 0x70, (byte) 0xd4, (byte) 0x75, (byte) 0x8f, (byte) 0x35, (byte) 0xbd, (byte) 0xa3, (byte) 0x8f, (byte) 0xef, (byte) 0x56, (byte) 0x23, (byte) 0xad, (byte) 0x71, (byte) 0x0b, (byte) 0x32, (byte) 0x33, (byte) 0xfb, (byte) 0x33, (byte) 0xac, (byte) 0xcb, (byte) 0x6d, (byte) 0x59, (byte) 0xa2, (byte) 0xdb, (byte) 0x68, (byte) 0xfc, (byte) 0xb7, (byte) 0x88, (byte) 0x90, (byte) 0x33, (byte) 0x57, (byte) 0x12, (byte) 0x6c, (byte) 0x00, (byte) 0xe0, (byte) 0xb4, (byte) 0x1e, (byte) 0x56, (byte) 0x3c, (byte) 0x21, (byte) 0x79, (byte) 0x17, (byte) 0xbc, (byte) 0x11, (byte) 0xd6, (byte) 0xa6, (byte) 0x00, (byte) 0xc2, (byte) 0x7d, (byte) 0x65, (byte) 0x89, (byte) 0x15, (byte) 0x23, (byte) 0xaf, (byte) 0xfe, (byte) 0x51, (byte) 0x7a, (byte) 0xc5, (byte) 0x94, (byte) 0x9b, (byte) 0x99, (byte) 0xe5, (byte) 0xf6, (byte) 0xe0, (byte) 0x93, (byte) 0xa6, (byte) 0x5f, (byte) 0x05, (byte) 0x9e, (byte) 0x20, (byte) 0xca, (byte) 0x2e, (byte) 0x65, (byte) 0x15, (byte) 0xf3, (byte) 0x6b, (byte) 0x0d, (byte) 0xe9, (byte) 0x92, (byte) 0x46, (byte) 0x75, (byte) 0x1b, (byte) 0x1b, (byte) 0xb6, (byte) 0xf8, (byte) 0xb4, (byte) 0x33, (byte) 0x7a, (byte) 0x3d, (byte) 0x97, (byte) 0xb2, (byte) 0xee, (byte) 0xfd, (byte) 0x8a, (byte) 0x5d, (byte) 0x77, (byte) 0xa6, (byte) 0xf4, (byte) 0xb0, (byte) 0xba, (byte) 0x3f, (byte) 0xc6, (byte) 0xed, (byte) 0xc1, (byte) 0x5e, (byte) 0x5a, (byte) 0xf2, (byte) 0x2a, (byte) 0x62, (byte) 0x46, (byte) 0xfc, (byte) 0x44, (byte) 0x08, (byte) 0x1a, (byte) 0x2a, (byte) 0x48, (byte) 0x24, (byte) 0x0e, (byte) 0x65, (byte) 0xff, (byte) 0xd0, (byte) 0xde, (byte) 0x23, (byte) 0x3a, (byte) 0xab, (byte) 0x1e, (byte) 0xd7, (byte) 0xf7, (byte) 0xbb, (byte) 0xb5, (byte) 0xfa, (byte) 0x1b, (byte) 0xec, (byte) 0x6a, (byte) 0xc4, (byte) 0xfe, (byte) 0xa8, (byte) 0x1d, (byte) 0x98, (byte) 0xbc, (byte) 0xfb, (byte) 0x48, (byte) 0xc2, (byte) 0x11, (byte) 0xda, (byte) 0xe9, (byte) 0xee, (byte) 0xa7, (byte) 0x78, (byte) 0x37, (byte) 0x61, (byte) 0xf9, (byte) 0x29, (byte) 0x2c, (byte) 0x49, (byte) 0x2f, (byte) 0xed, (byte) 0xf1, (byte) 0x9a, (byte) 0xa9, (byte) 0xac, (byte) 0x26, (byte) 0x37, (byte) 0xaf, (byte) 0xb5, (byte) 0xb4, (byte) 0xa9, (byte) 0x6f, (byte) 0x8a, (byte) 0x1f, (byte) 0xb0, (byte) 0xb8, (byte) 0x3a, (byte) 0x36, (byte) 0xd3, (byte) 0xfa, (byte) 0x15, (byte) 0xa5, (byte) 0x9e, (byte) 0xe5, (byte) 0x04, (byte) 0xdb, (byte) 0x68, (byte) 0x4e, (byte) 0xda, (byte) 0x3e, (byte) 0x21, (byte) 0xa3, (byte) 0xfa, (byte) 0x15, (byte) 0xc1, (byte) 0x36, (byte) 0x31, (byte) 0x6a, (byte) 0x7e, (byte) 0xdc, (byte) 0x6b, (byte) 0x5e, (byte) 0xa8, (byte) 0xb0, (byte) 0xe4, (byte) 0x00, (byte) 0x88, (byte) 0xfe, (byte) 0xce, (byte) 0xcd, (byte) 0x43, (byte) 0x13, (byte) 0x2b, (byte) 0x11, (byte) 0xb7, (byte) 0x9d, (byte) 0xca, (byte) 0x29, (byte) 0x85, (byte) 0x5a, (byte) 0xbc, (byte) 0xa7, (byte) 0xb0, (byte) 0xe8, (byte) 0xe1, (byte) 0xfa, (byte) 0x83, (byte) 0xd4, (byte) 0x16, (byte) 0x9f, (byte) 0x97, (byte) 0x0b, (byte) 0x68, (byte) 0x7d, (byte) 0xe4, (byte) 0x5b, (byte) 0x2f, (byte) 0x17, (byte) 0xd1, (byte) 0x47, (byte) 0x34, (byte) 0x5b, (byte) 0x6e, (byte) 0x6c, (byte) 0x00, (byte) 0xbe, (byte) 0x38, (byte) 0xe9, (byte) 0x37, (byte) 0xf8, (byte) 0xaa, (byte) 0xeb, (byte) 0xae, (byte) 0x17, (byte) 0x09, (byte) 0xe3, (byte) 0x84, (byte) 0x6b, (byte) 0xf8, (byte) 0xc4, (byte) 0x7a, (byte) 0x11, (byte) 0xfb, (byte) 0xd2, (byte) 0x17, (byte) 0x50, (byte) 0xa0, (byte) 0x75, (byte) 0x1a, (byte) 0xba, (byte) 0x5c, (byte) 0x50, (byte) 0x91, (byte) 0xc9, (byte) 0x43, (byte) 0x6b, (byte) 0xd9, (byte) 0x00, (byte) 0x56, (byte) 0x78, (byte) 0x89, (byte) 0xd1, (byte) 0x76, (byte) 0xa3, (byte) 0xdc, (byte) 0x05, (byte) 0xd8, (byte) 0x8e, (byte) 0x11, (byte) 0x8d, (byte) 0x18, (byte) 0x3d, (byte) 0x25, (byte) 0x9c, (byte) 0x82, (byte) 0x80, (byte) 0x8c, (byte) 0x14, (byte) 0x24, (byte) 0x7d, (byte) 0x6c, (byte) 0x0a, (byte) 0x94, (byte) 0x2d, (byte) 0xb9, (byte) 0x22, (byte) 0x91, (byte) 0x3f, (byte) 0x93, (byte) 0x54, (byte) 0xc9, (byte) 0x22, (byte) 0x59, (byte) 0x49, (byte) 0x08, (byte) 0x1a, (byte) 0x33, (byte) 0x4c, (byte) 0xac, (byte) 0xec, (byte) 0xd4, (byte) 0x22, (byte) 0x09, (byte) 0x88, (byte) 0x5d, (byte) 0x32, (byte) 0x60, (byte) 0x84, (byte) 0x3c, (byte) 0x2a, (byte) 0x02, (byte) 0x71, (byte) 0xea, (byte) 0x59, (byte) 0x77, (byte) 0x83, (byte) 0x98, (byte) 0xfe, (byte) 0x13, (byte) 0x2b, (byte) 0xf6, (byte) 0xdd, (byte) 0x2c, (byte) 0x8f, (byte) 0x0d, (byte) 0x93, (byte) 0x71, (byte) 0x13, (byte) 0x7f, (byte) 0xee, (byte) 0xd3, (byte) 0xf1, (byte) 0x20, (byte) 0x75, (byte) 0xb5, (byte) 0x97, (byte) 0xdb, (byte) 0xa0, (byte) 0x4e, (byte) 0xaa, (byte) 0x57, (byte) 0x76, (byte) 0xa2, (byte) 0x8e, (byte) 0x26, (byte) 0x09, (byte) 0x8f, (byte) 0xb0, (byte) 0xd2, (byte) 0xd0, (byte) 0xb4, (byte) 0x8d, (byte) 0x18, (byte) 0x62, (byte) 0xc3, (byte) 0xf4, (byte) 0x6f, (byte) 0xd5, (byte) 0x18, (byte) 0x25, (byte) 0xbd, (byte) 0x10, (byte) 0xa3, (byte) 0x93, (byte) 0x8e, (byte) 0xa1, (byte) 0x94, (byte) 0x73, (byte) 0x2b, (byte) 0x74, (byte) 0xaf, (byte) 0x4e, (byte) 0xe4, (byte) 0xb0, (byte) 0x43, (byte) 0x0b, (byte) 0x87, (byte) 0xe6, (byte) 0x39, (byte) 0x94, (byte) 0x0d, (byte) 0xa4, (byte) 0xae, (byte) 0xaa, (byte) 0xef, (byte) 0xa0, (byte) 0xfb, (byte) 0x29, (byte) 0x75, (byte) 0xb3, (byte) 0x59, (byte) 0x0e, (byte) 0xaa, (byte) 0x50, (byte) 0x3c, (byte) 0x40, (byte) 0x4f, (byte) 0x5f, (byte) 0x49, (byte) 0xdb, (byte) 0x40, (byte) 0x8c, (byte) 0x07, (byte) 0xf9, (byte) 0xbc, (byte) 0xf6, (byte) 0x07, (byte) 0x56, (byte) 0x86, (byte) 0x8f, (byte) 0x84, (byte) 0xe9, (byte) 0x98, (byte) 0x75, (byte) 0xe9, (byte) 0x7a, (byte) 0xc4, (byte) 0x8a, (byte) 0x4d, (byte) 0x1d, (byte) 0x74, (byte) 0x68, (byte) 0xd1, (byte) 0x89, (byte) 0xa5, (byte) 0xf3, (byte) 0x3f, (byte) 0x65, (byte) 0x7d, (byte) 0x0b, (byte) 0x58, (byte) 0xf1, (byte) 0x04, (byte) 0xa1, (byte) 0x27, (byte) 0xe5, (byte) 0xc9, (byte) 0x7f, (byte) 0x37, (byte) 0xd2, (byte) 0x11, (byte) 0x34, (byte) 0x27, (byte) 0xbb, (byte) 0x47, (byte) 0xd9, (byte) 0xfc, (byte) 0xa3, (byte) 0x60, (byte) 0x2e, (byte) 0x2f, (byte) 0x8e, (byte) 0x2f, (byte) 0x5a, (byte) 0x23, (byte) 0x6d, (byte) 0x78, (byte) 0xaf, (byte) 0x4b, (byte) 0x7e, (byte) 0x5e, (byte) 0x92, (byte) 0xfe, (byte) 0x63, (byte) 0x7f, (byte) 0x5f, (byte) 0xb7, (byte) 0x1c, (byte) 0x70, (byte) 0x49, (byte) 0x32, (byte) 0xc5, (byte) 0x27, (byte) 0xdf, (byte) 0xd3, (byte) 0xd6, (byte) 0x7e, (byte) 0x61, (byte) 0x2a, (byte) 0x12, (byte) 0xa3, (byte) 0xdc, (byte) 0xd0, (byte) 0x01, (byte) 0x0c, (byte) 0x7a, (byte) 0xb7, (byte) 0xdc, (byte) 0x3f, (byte) 0xd3, (byte) 0x06, (byte) 0x39, (byte) 0x35, (byte) 0x42, (byte) 0x00, (byte) 0xfa, (byte) 0x57, (byte) 0x6d, (byte) 0x51, (byte) 0x54, (byte) 0x23, (byte) 0x49, (byte) 0x2e, (byte) 0x37, (byte) 0xcd, (byte) 0xfc, (byte) 0x35, (byte) 0x43, (byte) 0x37, (byte) 0x6c, (byte) 0xc9, (byte) 0x92, (byte) 0x98, (byte) 0xcb, (byte) 0x91, (byte) 0x0c, (byte) 0xdd, (byte) 0xe3, (byte) 0x5b, (byte) 0xc7, (byte) 0x34, (byte) 0x4d, (byte) 0x17, (byte) 0xd4, (byte) 0xb1, (byte) 0xb5, (byte) 0xca, (byte) 0x26, (byte) 0xee, (byte) 0x02, (byte) 0x12, (byte) 0x54, (byte) 0x95, (byte) 0xad, (byte) 0x3c, (byte) 0x18, (byte) 0xb4, (byte) 0x30, (byte) 0x6b, (byte) 0xb9, (byte) 0x3a, (byte) 0xe5, (byte) 0x1b, (byte) 0x3d, (byte) 0x5f, (byte) 0xa9, (byte) 0x0b, (byte) 0xb3, (byte) 0xa7, (byte) 0xb4, (byte) 0x4c, (byte) 0xe5, (byte) 0xc6, (byte) 0x0a, (byte) 0x70, (byte) 0xc5, (byte) 0x6c, (byte) 0xc3, (byte) 0x72, (byte) 0xab, (byte) 0x6a, (byte) 0x67, (byte) 0x3e, (byte) 0xb5, (byte) 0xf9, (byte) 0xe1, (byte) 0x5f, (byte) 0x5f, (byte) 0x35, (byte) 0xce, (byte) 0xf7, (byte) 0x83, (byte) 0xe2, (byte) 0x89, (byte) 0xac, (byte) 0xd0, (byte) 0xf0, (byte) 0x71, (byte) 0x2f, (byte) 0x21, (byte) 0xb5, (byte) 0x2a, (byte) 0x1d, (byte) 0x46, (byte) 0x1b, (byte) 0xf4, (byte) 0x39, (byte) 0x10, (byte) 0x0a, (byte) 0x11, (byte) 0x38, (byte) 0xc1, (byte) 0xda, (byte) 0x19, (byte) 0xe7, (byte) 0xea, (byte) 0xd9, (byte) 0x3d, (byte) 0xd6, (byte) 0x09, (byte) 0x61, (byte) 0xdd, (byte) 0x7e, (byte) 0xe2, (byte) 0x38, (byte) 0x5a, (byte) 0x24, (byte) 0x49, (byte) 0x55, (byte) 0x23, (byte) 0x09, (byte) 0x6f, (byte) 0xe3, (byte) 0x37, (byte) 0x65, (byte) 0x9a, (byte) 0xad, (byte) 0x23, (byte) 0x57, (byte) 0x02, (byte) 0x03, (byte) 0x5b, (byte) 0x08, (byte) 0xdc, (byte) 0x25, (byte) 0xec, (byte) 0x8d, (byte) 0xfc, (byte) 0x74, (byte) 0xb2, (byte) 0xc6, (byte) 0x62, (byte) 0xe4, (byte) 0xa0, (byte) 0xef, (byte) 0xd6, (byte) 0xe9, (byte) 0xfc, (byte) 0x1e, (byte) 0x28, (byte) 0xa8, (byte) 0x76, (byte) 0x90, (byte) 0xfd, (byte) 0xaf, (byte) 0x1a, (byte) 0x55, (byte) 0x69, (byte) 0x14, (byte) 0xc9, (byte) 0xcb, (byte) 0xdf, (byte) 0x53, (byte) 0x0b, (byte) 0xb1, (byte) 0x20, (byte) 0x8d, (byte) 0xe7, (byte) 0x76, (byte) 0x5f, (byte) 0x08, (byte) 0x46, (byte) 0xe0, (byte) 0x50, (byte) 0xdd, (byte) 0xa8, (byte) 0x15, (byte) 0xe0, (byte) 0xa3, (byte) 0xbd, (byte) 0x6e, (byte) 0x93, (byte) 0xcf, (byte) 0xf7, (byte) 0x48, (byte) 0x01, (byte) 0xb3, (byte) 0x97, (byte) 0x09, (byte) 0x29, (byte) 0x8e, (byte) 0x7b, (byte) 0xa1, (byte) 0x22, (byte) 0x4e, (byte) 0x3e, (byte) 0x22, (byte) 0xf8, (byte) 0x52, (byte) 0xa1, (byte) 0xfa, (byte) 0xa0, (byte) 0x84, (byte) 0xff, (byte) 0x48, (byte) 0xd1, (byte) 0x50, (byte) 0x37, (byte) 0x77, (byte) 0x42, (byte) 0x46, (byte) 0x9f, (byte) 0x8a, (byte) 0xc0, (byte) 0x8e, (byte) 0xfc, (byte) 0xfa, (byte) 0x46, (byte) 0x79, (byte) 0x7b, (byte) 0x34, (byte) 0xce, (byte) 0x16, (byte) 0x60, (byte) 0x8f, (byte) 0x71, (byte) 0xc0, (byte) 0x32, (byte) 0xcc, (byte) 0xf8, (byte) 0xd4, (byte) 0x66, (byte) 0x5e, (byte) 0xb0, (byte) 0xe9, (byte) 0x02, (byte) 0x95, (byte) 0xf1, (byte) 0x2e, (byte) 0x28, (byte) 0x72, (byte) 0xe2, (byte) 0x3d, (byte) 0x89, (byte) 0x88, (byte) 0xa5, (byte) 0xb8, (byte) 0xd5, (byte) 0x2f, (byte) 0xc0, (byte) 0xdd, (byte) 0xda, (byte) 0x03, (byte) 0x33, (byte) 0xf3, (byte) 0xf9, (byte) 0x79, (byte) 0x5c, (byte) 0x6e, (byte) 0x2a, (byte) 0x2d, (byte) 0x84, (byte) 0xfd, (byte) 0xab, (byte) 0x03, (byte) 0x16, (byte) 0xe6, (byte) 0x14, (byte) 0xf4, (byte) 0x32, (byte) 0x24, (byte) 0x5e, (byte) 0xa3, (byte) 0x20, (byte) 0x51, (byte) 0x67, (byte) 0x24, (byte) 0xce, (byte) 0x55, (byte) 0xc7, (byte) 0xa8, (byte) 0x4c, (byte) 0xf0, (byte) 0x3b, (byte) 0x0c, (byte) 0xdd, (byte) 0xe7, (byte) 0xc3, (byte) 0xc8, (byte) 0xfa, (byte) 0xee, (byte) 0x08, (byte) 0xc0, (byte) 0xb0, (byte) 0xe9, (byte) 0x44, (byte) 0x25, (byte) 0x9b, (byte) 0x0f, (byte) 0x64, (byte) 0xac, (byte) 0x90, (byte) 0x32, (byte) 0x78, (byte) 0x51, (byte) 0xdb, (byte) 0x39, (byte) 0x64, (byte) 0x7a, (byte) 0x2c, (byte) 0x63, (byte) 0x7c, (byte) 0x1d, (byte) 0xe4, (byte) 0xba, (byte) 0xab, (byte) 0x7b, (byte) 0xd0, (byte) 0x37, (byte) 0x69, (byte) 0xdb, (byte) 0xde, (byte) 0xd8, (byte) 0x39, (byte) 0xcc, (byte) 0x72, (byte) 0x9e, (byte) 0x07, (byte) 0xb7, (byte) 0x96, (byte) 0xab, (byte) 0xbf, (byte) 0xe9, (byte) 0x99, (byte) 0xca, (byte) 0x0b, (byte) 0x2d, (byte) 0x9b, (byte) 0xe1, (byte) 0x9c, (byte) 0x9c, (byte) 0x6c, (byte) 0x76, (byte) 0x1c, (byte) 0x5c, (byte) 0x09, (byte) 0x38, (byte) 0x6f, (byte) 0x38, (byte) 0x1e, (byte) 0x71, (byte) 0xbc, (byte) 0xd2, (byte) 0x82, (byte) 0x82, (byte) 0x75, (byte) 0xe8, (byte) 0x8d, (byte) 0x4b, (byte) 0xea, (byte) 0xf9, (byte) 0x9c, (byte) 0xad, (byte) 0xa2, (byte) 0xde, (byte) 0x31, (byte) 0x23, (byte) 0x36, (byte) 0x39, (byte) 0x85, (byte) 0xf8, (byte) 0xa0, (byte) 0x72, (byte) 0x4b, (byte) 0x90, (byte) 0x1e, (byte) 0x9b, (byte) 0xac, (byte) 0x8e, (byte) 0xf4, (byte) 0x87, (byte) 0xbe, (byte) 0x89, (byte) 0x87, (byte) 0x1c, (byte) 0x5a, (byte) 0x6b, (byte) 0x74, (byte) 0xcf, (byte) 0xf0, (byte) 0xf6, (byte) 0x06, (byte) 0x56, (byte) 0x7e, (byte) 0x35, (byte) 0x0e, (byte) 0x01, (byte) 0x4c, (byte) 0xbe, (byte) 0xf5, (byte) 0x36, (byte) 0xcc, (byte) 0x48, (byte) 0x3d, (byte) 0x3f, (byte) 0x3b, (byte) 0x5c, (byte) 0x78, (byte) 0x84, (byte) 0x19, (byte) 0x5d, (byte) 0x86, (byte) 0x68, (byte) 0xf0, (byte) 0x1c, (byte) 0x3f, (byte) 0x77, (byte) 0xff, (byte) 0x6c, (byte) 0xb5, (byte) 0xcb, (byte) 0xd1, (byte) 0x42, (byte) 0xc9, (byte) 0x5e, (byte) 0x72, (byte) 0x2c, (byte) 0x27, (byte) 0x74, (byte) 0x81, (byte) 0xff, (byte) 0xa4, (byte) 0x2d, (byte) 0x9e, (byte) 0x91, (byte) 0x0d, (byte) 0x4b, (byte) 0x17, (byte) 0x70, (byte) 0x3e, (byte) 0x5a, (byte) 0xa6, (byte) 0x50, (byte) 0xa3, (byte) 0x78, (byte) 0xdd, (byte) 0x19, (byte) 0x6b, (byte) 0x6f, (byte) 0x4a, (byte) 0xf4, (byte) 0x84, (byte) 0x0b, (byte) 0xf5, (byte) 0xde, (byte) 0xbd, (byte) 0xd0, (byte) 0x8b, (byte) 0x84, (byte) 0xe2, (byte) 0xa1, (byte) 0xf2, (byte) 0xda, (byte) 0x01, (byte) 0x54, (byte) 0x4d, (byte) 0xab, (byte) 0x07, (byte) 0x33, (byte) 0x46, (byte) 0xa7, (byte) 0x5e, (byte) 0x94, (byte) 0x28, (byte) 0x73, (byte) 0xc8, (byte) 0xc7, (byte) 0xd5, (byte) 0x8a, (byte) 0x5b, (byte) 0x67, (byte) 0x5c, (byte) 0xee, (byte) 0x47, (byte) 0xbb, (byte) 0x94, (byte) 0x3c, (byte) 0xa9, (byte) 0xc8, (byte) 0x49, (byte) 0x71, (byte) 0xa5, (byte) 0xaa, (byte) 0xd6, (byte) 0xf0, (byte) 0x61, (byte) 0x08, (byte) 0x8e, (byte) 0xee, (byte) 0xec, (byte) 0x42, (byte) 0xbe, (byte) 0xff, (byte) 0x27, (byte) 0x09, (byte) 0x33, (byte) 0xac, (byte) 0xaa, (byte) 0x39, (byte) 0x6c, (byte) 0x64, (byte) 0xcd, (byte) 0x20, (byte) 0x44, (byte) 0xef, (byte) 0x6a, (byte) 0xf0, (byte) 0xa4, (byte) 0x8b, (byte) 0xd9, (byte) 0x13, (byte) 0xce, (byte) 0xc7, (byte) 0x20, (byte) 0xad, (byte) 0x0b, (byte) 0x31, (byte) 0xc9, (byte) 0x9e, (byte) 0xd0, (byte) 0x66, (byte) 0x66, (byte) 0x6a, (byte) 0x44, (byte) 0x84, (byte) 0x94, (byte) 0xe2, (byte) 0x63, (byte) 0x00, (byte) 0x21, (byte) 0x41, (byte) 0x59, (byte) 0xa0, (byte) 0xf8, (byte) 0x78, (byte) 0x85, (byte) 0x88, (byte) 0x58, (byte) 0xb7, (byte) 0xb3, (byte) 0x7c, (byte) 0x1d, (byte) 0x63, (byte) 0x51, (byte) 0xd8, (byte) 0xfa, (byte) 0x8d, (byte) 0xd5, (byte) 0x90, (byte) 0xec, (byte) 0xa7, (byte) 0x4f, (byte) 0xa8, (byte) 0x61, (byte) 0xaa, (byte) 0xfd, (byte) 0x5e, (byte) 0x3d, (byte) 0x48, (byte) 0xbc, (byte) 0x94, (byte) 0x4f, (byte) 0xad, (byte) 0x12, (byte) 0x1e, (byte) 0x75, (byte) 0xf7, (byte) 0x45, (byte) 0xb6, (byte) 0x35, (byte) 0x7d, (byte) 0x69, (byte) 0xb2, (byte) 0xd5, (byte) 0xb6, (byte) 0x71, (byte) 0xfb, (byte) 0x81, (byte) 0xba, (byte) 0x73, (byte) 0xd3, (byte) 0xa0, (byte) 0x51, (byte) 0x94, (byte) 0xb9, (byte) 0x37, (byte) 0x48, (byte) 0x33, (byte) 0x3f, (byte) 0xe2, (byte) 0xcc, (byte) 0x4d, (byte) 0x5a, (byte) 0x45, (byte) 0xa7, (byte) 0x3b, (byte) 0x70, (byte) 0x5f, (byte) 0x48, (byte) 0xb4, (byte) 0x17, (byte) 0x7f, (byte) 0x4a, (byte) 0x6b, (byte) 0xa2, (byte) 0xb1, (byte) 0x6d, (byte) 0xa8, (byte) 0x93, (byte) 0x26, (byte) 0x38, (byte) 0x5b, (byte) 0x02, (byte) 0x33, (byte) 0xfb, (byte) 0xcc, (byte) 0x05, (byte) 0xbe, (byte) 0x70, (byte) 0xab, (byte) 0x7c, (byte) 0x5a, (byte) 0x88, (byte) 0xb6, (byte) 0xdf, (byte) 0x3e, (byte) 0x79, (byte) 0x54, (byte) 0x6e, (byte) 0xec, (byte) 0x7b, (byte) 0x91, (byte) 0xe5, (byte) 0xdb, (byte) 0xe1, (byte) 0x04, (byte) 0xa6, (byte) 0x79, (byte) 0xa2, (byte) 0x8a, (byte) 0xdc, (byte) 0xec, (byte) 0xa5, (byte) 0xfc, (byte) 0xab, (byte) 0x4c, (byte) 0xb5, (byte) 0x60, (byte) 0xd9, (byte) 0xf8, (byte) 0x41, (byte) 0xdd, (byte) 0x5e, (byte) 0xb5, (byte) 0xb3, (byte) 0x26, (byte) 0x05, (byte) 0xe6, (byte) 0x54, (byte) 0x68, (byte) 0x48, (byte) 0x46, (byte) 0x16, (byte) 0xa3, (byte) 0xb2, (byte) 0xdc, (byte) 0x47, (byte) 0xb1, (byte) 0x83, (byte) 0x35, (byte) 0xcc, (byte) 0xc7, (byte) 0x35, (byte) 0x02, (byte) 0x22, (byte) 0xb7, (byte) 0x4c, (byte) 0xc5, (byte) 0x89, (byte) 0x72, (byte) 0x43, (byte) 0xe2, (byte) 0xe4, (byte) 0x35, (byte) 0x23, (byte) 0x78, (byte) 0x28, (byte) 0x5f, (byte) 0x24, (byte) 0x3c, (byte) 0xf9, (byte) 0xf3, (byte) 0x48, (byte) 0x23, (byte) 0xb7, (byte) 0x0a, (byte) 0x30, (byte) 0x2f, (byte) 0x9d, (byte) 0xe4, (byte) 0x59, (byte) 0x02, (byte) 0x11, (byte) 0x8e, (byte) 0xfe, (byte) 0x53, (byte) 0x14, (byte) 0xa9, (byte) 0xea, (byte) 0x2b, (byte) 0x47, (byte) 0x12, (byte) 0xa0, (byte) 0xd1, (byte) 0xc0, (byte) 0xa9, (byte) 0xee, (byte) 0x5f, (byte) 0xac, (byte) 0x17, (byte) 0x95, (byte) 0xdc, (byte) 0xb2, (byte) 0x48, (byte) 0xc7, (byte) 0xe6, (byte) 0x75, (byte) 0x16, (byte) 0xcc, (byte) 0xc2, (byte) 0x2f, (byte) 0x41, (byte) 0x71, (byte) 0x13, (byte) 0xe1, (byte) 0x2f, (byte) 0xea, (byte) 0x52, (byte) 0xb1, (byte) 0xa7, (byte) 0x2b, (byte) 0x3e, (byte) 0x93, (byte) 0xd1, (byte) 0x06, (byte) 0x70, (byte) 0xc5, (byte) 0x94, (byte) 0x5d, (byte) 0x1c, (byte) 0x05, (byte) 0x8d, (byte) 0x75, (byte) 0x2e, (byte) 0x7e, (byte) 0x03, (byte) 0x63, (byte) 0x91, (byte) 0xbf, (byte) 0x20, (byte) 0x6d, (byte) 0x85, (byte) 0x8f, (byte) 0xc5, (byte) 0x9d, (byte) 0x2f, (byte) 0xf7, (byte) 0xe9, (byte) 0x95, (byte) 0xd4, (byte) 0x4f, (byte) 0x1f, (byte) 0xa3, (byte) 0x10, (byte) 0x65, (byte) 0xc5, (byte) 0xdb, (byte) 0xf4, (byte) 0x19, (byte) 0xb9, (byte) 0x61, (byte) 0xba, (byte) 0xae, (byte) 0x2c, (byte) 0x5c, (byte) 0x58, (byte) 0xa6, (byte) 0x1b, (byte) 0x81, (byte) 0x0d, (byte) 0x3a, (byte) 0x69, (byte) 0x8a, (byte) 0x2e, (byte) 0x1e, (byte) 0x28, (byte) 0x7d, (byte) 0x68, (byte) 0xc0, (byte) 0xf2, (byte) 0xa5, (byte) 0x9d, (byte) 0xc1, (byte) 0x41, (byte) 0xa0, (byte) 0xd8, (byte) 0x25, (byte) 0xd9, (byte) 0xe8, (byte) 0xb8, (byte) 0x32, (byte) 0xce, (byte) 0x62, (byte) 0xd4, (byte) 0x9a, (byte) 0xcb, (byte) 0xec, (byte) 0xf0, (byte) 0x08, (byte) 0x30, (byte) 0x4e, (byte) 0xd1, (byte) 0xfe, (byte) 0x40, (byte) 0x6a, (byte) 0x32, (byte) 0x99, (byte) 0x19, (byte) 0x0c, (byte) 0xee, (byte) 0x81, (byte) 0xb4, (byte) 0x36, (byte) 0x27, (byte) 0x30, (byte) 0x4b, (byte) 0xf2, (byte) 0x0d, (byte) 0xd6, (byte) 0x9c, (byte) 0x8c, (byte) 0x9b, (byte) 0x54, (byte) 0x6b, (byte) 0x54, (byte) 0xad, (byte) 0x13, (byte) 0xfc, (byte) 0xd1, (byte) 0x3a, (byte) 0x95, (byte) 0xb8, (byte) 0x0e, (byte) 0xdf, (byte) 0xe2, (byte) 0x2f, (byte) 0xc9, (byte) 0x17, (byte) 0x3a, (byte) 0x8b, (byte) 0x2d, (byte) 0xa8, (byte) 0xc9, (byte) 0x75, (byte) 0x30, (byte) 0x18, (byte) 0xfd, (byte) 0x0c, (byte) 0xcf, (byte) 0x50, (byte) 0xbb, (byte) 0x66, (byte) 0xec, (byte) 0xe7, (byte) 0xf1, (byte) 0xfc, (byte) 0x47, (byte) 0x96, (byte) 0x8f, (byte) 0x20, (byte) 0xf5, (byte) 0x14, (byte) 0x54, (byte) 0x45, (byte) 0xc4, (byte) 0x2b, (byte) 0x5e, (byte) 0xbd, (byte) 0xe2, (byte) 0x1d, (byte) 0xe9, (byte) 0x35, (byte) 0xf1, (byte) 0x38, (byte) 0x76, (byte) 0xa1, (byte) 0x79, (byte) 0xea, (byte) 0xa4, (byte) 0x85, (byte) 0x7b, (byte) 0xdf, (byte) 0x0e, (byte) 0x0d, (byte) 0x82, (byte) 0xa4, (byte) 0x59, (byte) 0x24, (byte) 0x45, (byte) 0x92, (byte) 0x6a, (byte) 0x23, (byte) 0x0c, (byte) 0x74, (byte) 0xd9, (byte) 0x33, (byte) 0x34, (byte) 0x9f, (byte) 0xc0, (byte) 0x5c, (byte) 0x4d, (byte) 0x8d, (byte) 0x50, (byte) 0x25, (byte) 0x02, (byte) 0xbd, (byte) 0x28, (byte) 0xc6, (byte) 0xd3, (byte) 0xd0, (byte) 0xd6, (byte) 0x35, (byte) 0x18, (byte) 0xac, (byte) 0x9c, (byte) 0x00, (byte) 0x3f, (byte) 0x4e, (byte) 0xae, (byte) 0x50, (byte) 0x08, (byte) 0xed, (byte) 0xb5, (byte) 0x49, (byte) 0x1e, (byte) 0x66, (byte) 0x71, (byte) 0x72, (byte) 0xf2, (byte) 0x05, (byte) 0xfd, (byte) 0xb5, (byte) 0x80, (byte) 0xc5, (byte) 0xd5, (byte) 0x51, (byte) 0x2d, (byte) 0x04, (byte) 0x1d, (byte) 0x62, (byte) 0x1b, (byte) 0x48, (byte) 0xbf, (byte) 0xa8, (byte) 0x51, (byte) 0x32, (byte) 0xd5, (byte) 0xd4, (byte) 0x09, (byte) 0xcb, (byte) 0xcc, (byte) 0x1d, (byte) 0x81, (byte) 0xf5, (byte) 0x49, (byte) 0x4e, (byte) 0x8b, (byte) 0xd7, (byte) 0xc5, (byte) 0xbf, (byte) 0x64, (byte) 0x72, (byte) 0x4b, (byte) 0x5f, (byte) 0xbc, (byte) 0xf8, (byte) 0x14, (byte) 0x57, (byte) 0xd3, (byte) 0x00, (byte) 0xce, (byte) 0x37, (byte) 0x5e, (byte) 0x1f, (byte) 0x4a, (byte) 0x62, (byte) 0x80, (byte) 0xbe, (byte) 0x0f, (byte) 0x6a, (byte) 0xee, (byte) 0xee, (byte) 0x02, (byte) 0x25, (byte) 0xa3, (byte) 0x1f, (byte) 0x9d, (byte) 0x85, (byte) 0x85, (byte) 0x31, (byte) 0xf2, (byte) 0xa6, (byte) 0x18, (byte) 0x45, (byte) 0x4e, (byte) 0xa3, (byte) 0xa9, (byte) 0x75, (byte) 0xc5, (byte) 0x26, (byte) 0x64, (byte) 0x2f, (byte) 0x34, (byte) 0xd1, (byte) 0x50, (byte) 0x81, (byte) 0x09, (byte) 0x3b, (byte) 0xa2, (byte) 0x2a, (byte) 0xdd, (byte) 0x19, (byte) 0x53, (byte) 0xd3, (byte) 0x9f, (byte) 0x7b, (byte) 0xad, (byte) 0xad, (byte) 0xf6, (byte) 0xd0, (byte) 0xba, (byte) 0x92, (byte) 0xc6, (byte) 0x4a, (byte) 0xe6, (byte) 0x6e, (byte) 0x47, (byte) 0x73, (byte) 0x65, (byte) 0xdb, (byte) 0x16, (byte) 0x72, (byte) 0xff, (byte) 0x9f, (byte) 0x54, (byte) 0x02, (byte) 0x41, (byte) 0xa6, (byte) 0x09, (byte) 0x78, (byte) 0x17, (byte) 0xec, (byte) 0x47, (byte) 0xbf, (byte) 0xbd, (byte) 0x24, (byte) 0xe9, (byte) 0x37, (byte) 0x54, (byte) 0xba, (byte) 0xf3, (byte) 0xb2, (byte) 0xb5, (byte) 0x5c, (byte) 0xbf, (byte) 0xf1, (byte) 0xe4, (byte) 0x5f, (byte) 0xa0, (byte) 0xb4, (byte) 0x79, (byte) 0xfb, (byte) 0x1d, (byte) 0xb9, (byte) 0x96, (byte) 0xe7, (byte) 0x1e, (byte) 0xf7, (byte) 0x64, (byte) 0x92, (byte) 0x9e, (byte) 0x62, (byte) 0x72, (byte) 0xd6, (byte) 0x3e, (byte) 0xbf, (byte) 0xea, (byte) 0x7c, (byte) 0x44, (byte) 0x7d, (byte) 0xc7, (byte) 0xff, (byte) 0x7b, (byte) 0xbd, (byte) 0x05, (byte) 0x7d, (byte) 0xf6, (byte) 0x06, (byte) 0x67, (byte) 0x37, (byte) 0x4e, (byte) 0xb9, (byte) 0x8e, (byte) 0x3c, (byte) 0x39, (byte) 0xa1, (byte) 0xe8, (byte) 0xf7, (byte) 0xdb, (byte) 0x5b, (byte) 0x98, (byte) 0x7f, (byte) 0x0a, (byte) 0xa9, (byte) 0x98, (byte) 0xdc, (byte) 0x61, (byte) 0x94, (byte) 0xef, (byte) 0x40, (byte) 0x38, (byte) 0x5b, (byte) 0x38, (byte) 0x71, (byte) 0xd3, (byte) 0xac, (byte) 0x95, (byte) 0x5b, (byte) 0x65, (byte) 0x65, (byte) 0x07, (byte) 0xf6, (byte) 0x39, (byte) 0x44, (byte) 0xb4, (byte) 0x3a, (byte) 0xae, (byte) 0x97, (byte) 0x0f, (byte) 0x59, (byte) 0xf0, (byte) 0xd1, (byte) 0x18, (byte) 0x31, (byte) 0x6b, (byte) 0xbc, (byte) 0xe9, (byte) 0x49, (byte) 0xef, (byte) 0x6a, (byte) 0x57, (byte) 0x69, (byte) 0x8e, (byte) 0x90, (byte) 0xd1, (byte) 0xfa, (byte) 0xf0, (byte) 0x92, (byte) 0x43, (byte) 0x93, (byte) 0x7f, (byte) 0xad, (byte) 0xf0, (byte) 0x5e, (byte) 0xec, (byte) 0x51, (byte) 0x00, (byte) 0xc6, (byte) 0x3b, (byte) 0x12, (byte) 0xbf, (byte) 0xfb, (byte) 0x7d, (byte) 0xb4, (byte) 0x07, (byte) 0x6b, (byte) 0x7f, (byte) 0xe4, (byte) 0xb9, (byte) 0x6e, (byte) 0xc0, (byte) 0x3d, (byte) 0xd8, (byte) 0x57, (byte) 0x73, (byte) 0xd8, (byte) 0xbb, (byte) 0x20, (byte) 0x59, (byte) 0x5e, (byte) 0x39, (byte) 0x78, (byte) 0x55, (byte) 0xcb, (byte) 0xf8, (byte) 0x2b, (byte) 0x0b, (byte) 0x95, (byte) 0x09, (byte) 0xbe, (byte) 0x14, (byte) 0xde, (byte) 0xc6, (byte) 0x9a, (byte) 0x3e, (byte) 0x2f, (byte) 0x19, (byte) 0x77, (byte) 0x13, (byte) 0x9e, (byte) 0x38, (byte) 0xa6, (byte) 0x3d, (byte) 0x41, (byte) 0x62, (byte) 0xe0, (byte) 0x4a, (byte) 0x9d, (byte) 0xf8, (byte) 0x2c, (byte) 0x60, (byte) 0x73, (byte) 0x0e, (byte) 0xb1, (byte) 0xc1, (byte) 0x94, (byte) 0x24, (byte) 0x82, (byte) 0x86, (byte) 0x88, (byte) 0x4b, (byte) 0xeb, (byte) 0xb7, (byte) 0x9a, (byte) 0x87, (byte) 0xfd, (byte) 0x6d, (byte) 0x16, (byte) 0xb3, (byte) 0x1a, (byte) 0xf7, (byte) 0x1e, (byte) 0xce, (byte) 0x37, (byte) 0xa0, (byte) 0xf5, (byte) 0xd3, (byte) 0xd5, (byte) 0x06, (byte) 0x01, (byte) 0xdc, (byte) 0x27, (byte) 0x1c, (byte) 0x20, (byte) 0x21, (byte) 0x35, (byte) 0xad, (byte) 0x6b, (byte) 0xf7, (byte) 0x87, (byte) 0x8f, (byte) 0xce, (byte) 0x69, (byte) 0x14, (byte) 0x9d, (byte) 0x0a, (byte) 0xec, (byte) 0xab, (byte) 0x1a, (byte) 0x24, (byte) 0xd7, (byte) 0x55, (byte) 0xa9, (byte) 0x50, (byte) 0x50, (byte) 0xce, (byte) 0x7c, (byte) 0xea, (byte) 0xd6, (byte) 0x1a, (byte) 0x69, (byte) 0x7b, (byte) 0xec, (byte) 0x7e, (byte) 0x85, (byte) 0xec, (byte) 0x7a, (byte) 0x42, (byte) 0x86, (byte) 0xd0, (byte) 0x77, (byte) 0x92, (byte) 0xfe, (byte) 0x45, (byte) 0x19, (byte) 0x73, (byte) 0x13, (byte) 0xfc, (byte) 0x8d, (byte) 0x7b, (byte) 0x0f, (byte) 0x93, (byte) 0x40, (byte) 0x37, (byte) 0x0b, (byte) 0x4f, (byte) 0x29, (byte) 0xcf, (byte) 0x5f, (byte) 0xf9, (byte) 0x21, (byte) 0x2a, (byte) 0xcf, (byte) 0x09, (byte) 0x1d, (byte) 0x47, (byte) 0xb1, (byte) 0x90, (byte) 0x09, (byte) 0x15, (byte) 0xf5, (byte) 0x0c, (byte) 0x0f, (byte) 0xec, (byte) 0x8d, (byte) 0xdb, (byte) 0xbc, (byte) 0x81, (byte) 0xfb, (byte) 0xd0, (byte) 0xef, (byte) 0xd2, (byte) 0xcb, (byte) 0x8e, (byte) 0x0b, (byte) 0xd8, (byte) 0xf8, (byte) 0x85, (byte) 0x0c, (byte) 0x49, (byte) 0xf7, (byte) 0x53, (byte) 0x6a};

  static final byte[] BYTES_LONG_EXPECTED = {
    (byte) 99, (byte) 156, (byte) 217, (byte) 204, (byte) 228, (byte) 108, (byte) 166, (byte) 81, (byte) 211, (byte) 108, (byte) 66, (byte) 208, (byte) 14, (byte) 218, (byte) 72, (byte) 6, (byte) 87, (byte) 89, (byte) 238, (byte) 53, (byte) 238, (byte) 91, (byte) 84, (byte) 42, (byte) 233, (byte) 37, (byte) 171, (byte) 218, (byte) 2, (byte) 126, (byte) 37, (byte) 45, (byte) 103, (byte) 241, (byte) 225, (byte) 229, (byte) 189, (byte) 28, (byte) 95, (byte) 204, (byte) 20, (byte) 220, (byte) 38, (byte) 242, (byte) 213, (byte) 211, (byte) 246, (byte) 246, (byte) 209, (byte) 171, (byte) 246, (byte) 180, (byte) 158, (byte) 101, (byte) 140, (byte) 68, (byte) 73, (byte) 240, (byte) 95, (byte) 97, (byte) 238, (byte) 91, (byte) 80, (byte) 144, (byte) 207, (byte) 151, (byte) 39, (byte) 92, (byte) 129, (byte) 214, (byte) 35, (byte) 166, (byte) 34, (byte) 38, (byte) 149, (byte) 212, (byte) 23, (byte) 16, (byte) 183, (byte) 198, (byte) 108, (byte) 127, (byte) 157, (byte) 202, (byte) 173, (byte) 113, (byte) 55, (byte) 125, (byte) 151, (byte) 67, (byte) 43, (byte) 83, (byte) 169, (byte) 142, (byte) 132, (byte) 245, (byte) 133, (byte) 35, (byte) 1, (byte) 253, (byte) 145, (byte) 59, (byte) 25, (byte) 129, (byte) 145, (byte) 14, (byte) 143, (byte) 136, (byte) 148, (byte) 242, (byte) 107, (byte) 53, (byte) 223, (byte) 36, (byte) 89, (byte) 115, (byte) 184, (byte) 64, (byte) 151, (byte) 155, (byte) 190, (byte) 123, (byte) 12, (byte) 57, (byte) 163, (byte) 189, (byte) 210, (byte) 10, (byte) 142, (byte) 2, (byte) 226, (byte) 43, (byte) 188, (byte) 133, (byte) 194, (byte) 122, (byte) 173, (byte) 2, (byte) 87, (byte) 71, (byte) 42, (byte) 59, (byte) 131, (byte) 67, (byte) 254, (byte) 113, (byte) 119, (byte) 217, (byte) 113, (byte) 115, (byte) 173, (byte) 136, (byte) 140, (byte) 245, (byte) 248, (byte) 135, (byte) 105, (byte) 83, (byte) 105, (byte) 190, (byte) 230, (byte) 137, (byte) 250, (byte) 250, (byte) 250, (byte) 168, (byte) 101, (byte) 9, (byte) 34, (byte) 195, (byte) 206, (byte) 219, (byte) 212, (byte) 70, (byte) 109, (byte) 117, (byte) 3, (byte) 174, (byte) 201, (byte) 210, (byte) 75, (byte) 180, (byte) 172, (byte) 121, (byte) 247, (byte) 47, (byte) 77, (byte) 120, (byte) 213, (byte) 209, (byte) 141, (byte) 166, (byte) 141, (byte) 53, (byte) 60, (byte) 48, (byte) 153, (byte) 221, (byte) 132, (byte) 221, (byte) 69, (byte) 47, (byte) 244, (byte) 218, (byte) 171, (byte) 8, (byte) 8, (byte) 175, (byte) 182, (byte) 214, (byte) 117, (byte) 179, (byte) 117, (byte) 229, (byte) 98, (byte) 166, (byte) 27, (byte) 250, (byte) 70, (byte) 93, (byte) 39, (byte) 240, (byte) 135, (byte) 118, (byte) 183, (byte) 211, (byte) 42, (byte) 9, (byte) 4, (byte) 124, (byte) 77, (byte) 204, (byte) 249, (byte) 168, (byte) 251, (byte) 124, (byte) 226, (byte) 46, (byte) 252, (byte) 180, (byte) 73, (byte) 56, (byte) 18, (byte) 144, (byte) 247, (byte) 171, (byte) 231, (byte) 94, (byte) 163, (byte) 79, (byte) 138, (byte) 28, (byte) 205, (byte) 163, (byte) 187, (byte) 191, (byte) 241, (byte) 177, (byte) 199, (byte) 158, (byte) 143, (byte) 249, (byte) 32, (byte) 0, (byte) 60, (byte) 62, (byte) 47, (byte) 212, (byte) 246, (byte) 161, (byte) 201, (byte) 185, (byte) 2, (byte) 62, (byte) 85, (byte) 106, (byte) 49, (byte) 222, (byte) 84, (byte) 173, (byte) 90, (byte) 53, (byte) 86, (byte) 21, (byte) 72, (byte) 72, (byte) 255, (byte) 95, (byte) 89, (byte) 90, (byte) 50, (byte) 20, (byte) 148, (byte) 103, (byte) 26, (byte) 189, (byte) 80, (byte) 42, (byte) 68, (byte) 61, (byte) 2, (byte) 24, (byte) 216, (byte) 220, (byte) 235, (byte) 179, (byte) 142, (byte) 172, (byte) 147, (byte) 197, (byte) 202, (byte) 255, (byte) 220, (byte) 54, (byte) 44, (byte) 52, (byte) 197, (byte) 161, (byte) 120, (byte) 46, (byte) 148, (byte) 30, (byte) 30, (byte) 189, (byte) 249, (byte) 98, (byte) 19, (byte) 251, (byte) 202, (byte) 9, (byte) 79, (byte) 60, (byte) 97, (byte) 181, (byte) 232, (byte) 110, (byte) 26, (byte) 242, (byte) 33, (byte) 162, (byte) 248, (byte) 19, (byte) 167, (byte) 234, (byte) 196, (byte) 115, (byte) 19, (byte) 114, (byte) 41, (byte) 174, (byte) 248, (byte) 122, (byte) 221, (byte) 81, (byte) 241, (byte) 42, (byte) 11, (byte) 164, (byte) 139, (byte) 148, (byte) 138, (byte) 241, (byte) 96, (byte) 73, (byte) 202, (byte) 117, (byte) 22, (byte) 91, (byte) 62, (byte) 113, (byte) 100, (byte) 194, (byte) 142, (byte) 46, (byte) 48, (byte) 4, (byte) 213, (byte) 226, (byte) 225, (byte) 73, (byte) 157, (byte) 117, (byte) 10, (byte) 39, (byte) 8, (byte) 180, (byte) 111, (byte) 222, (byte) 54, (byte) 24, (byte) 11, (byte) 133, (byte) 244, (byte) 11, (byte) 93, (byte) 144, (byte) 106, (byte) 73, (byte) 192, (byte) 184, (byte) 81, (byte) 217, (byte) 72, (byte) 7, (byte) 26, (byte) 144, (byte) 180, (byte) 9, (byte) 251, (byte) 3, (byte) 50, (byte) 2, (byte) 17, (byte) 199, (byte) 71, (byte) 36, (byte) 51, (byte) 53, (byte) 123, (byte) 47, (byte) 199, (byte) 126, (byte) 214, (byte) 228, (byte) 97, (byte) 57, (byte) 252, (byte) 182, (byte) 33, (byte) 41, (byte) 143, (byte) 131, (byte) 95, (byte) 233, (byte) 180, (byte) 193, (byte) 35, (byte) 245, (byte) 58, (byte) 64, (byte) 185, (byte) 103, (byte) 233, (byte) 206, (byte) 120, (byte) 227, (byte) 208, (byte) 67, (byte) 80, (byte) 206, (byte) 38, (byte) 46, (byte) 127, (byte) 233, (byte) 111, (byte) 226, (byte) 38, (byte) 64, (byte) 9, (byte) 91, (byte) 241, (byte) 158, (byte) 17, (byte) 190, (byte) 244, (byte) 6, (byte) 246, (byte) 219, (byte) 170, (byte) 94, (byte) 54, (byte) 230, (byte) 60, (byte) 132, (byte) 216, (byte) 184, (byte) 13, (byte) 23, (byte) 209, (byte) 35, (byte) 180, (byte) 185, (byte) 240, (byte) 198, (byte) 185, (byte) 63, (byte) 167, (byte) 9, (byte) 173, (byte) 86, (byte) 132, (byte) 142, (byte) 80, (byte) 148, (byte) 36, (byte) 24, (byte) 72, (byte) 166, (byte) 94, (byte) 27, (byte) 226, (byte) 122, (byte) 217, (byte) 192, (byte) 218, (byte) 78, (byte) 154, (byte) 112, (byte) 223, (byte) 41, (byte) 43, (byte) 103, (byte) 214, (byte) 61, (byte) 0, (byte) 243, (byte) 28, (byte) 145, (byte) 206, (byte) 186, (byte) 220, (byte) 51, (byte) 159, (byte) 147, (byte) 239, (byte) 60, (byte) 254, (byte) 219, (byte) 33, (byte) 61, (byte) 47, (byte) 193, (byte) 2, (byte) 248, (byte) 53, (byte) 119, (byte) 122, (byte) 165, (byte) 236, (byte) 209, (byte) 176, (byte) 205, (byte) 53, (byte) 201, (byte) 146, (byte) 114, (byte) 252, (byte) 233, (byte) 200, (byte) 124, (byte) 106, (byte) 57, (byte) 32, (byte) 254, (byte) 24, (byte) 36, (byte) 90, (byte) 247, (byte) 84, (byte) 72, (byte) 29, (byte) 146, (byte) 250, (byte) 66, (byte) 51, (byte) 8, (byte) 98, (byte) 43, (byte) 209, (byte) 110, (byte) 252, (byte) 220, (byte) 29, (byte) 238, (byte) 236, (byte) 187, (byte) 247, (byte) 243, (byte) 42, (byte) 55, (byte) 204, (byte) 104, (byte) 95, (byte) 61, (byte) 27, (byte) 251, (byte) 178, (byte) 255, (byte) 89, (byte) 181, (byte) 35, (byte) 44, (byte) 112, (byte) 245, (byte) 36, (byte) 200, (byte) 95, (byte) 233, (byte) 12, (byte) 31, (byte) 127, (byte) 224, (byte) 198, (byte) 111, (byte) 13, (byte) 114, (byte) 175, (byte) 59, (byte) 114, (byte) 141, (byte) 136, (byte) 48, (byte) 51, (byte) 171, (byte) 1, (byte) 183, (byte) 15, (byte) 180, (byte) 168, (byte) 52, (byte) 138, (byte) 204, (byte) 92, (byte) 84, (byte) 34, (byte) 73, (byte) 69, (byte) 160, (byte) 63, (byte) 55, (byte) 48, (byte) 104, (byte) 175, (byte) 212, (byte) 11, (byte) 64, (byte) 167, (byte) 148, (byte) 174, (byte) 141, (byte) 209, (byte) 170, (byte) 169, (byte) 154, (byte) 209, (byte) 92, (byte) 23, (byte) 166, (byte) 207, (byte) 80, (byte) 224, (byte) 236, (byte) 213, (byte) 168, (byte) 109, (byte) 32, (byte) 254, (byte) 160, (byte) 99, (byte) 120, (byte) 248, (byte) 234, (byte) 223, (byte) 254, (byte) 247, (byte) 25, (byte) 159, (byte) 81, (byte) 20, (byte) 1, (byte) 230, (byte) 155, (byte) 121, (byte) 18, (byte) 107, (byte) 55, (byte) 147, (byte) 73, (byte) 26, (byte) 195, (byte) 215, (byte) 206, (byte) 120, (byte) 239, (byte) 30, (byte) 0, (byte) 6, (byte) 7, (byte) 35, (byte) 51, (byte) 106, (byte) 250, (byte) 216, (byte) 170, (byte) 201, (byte) 20, (byte) 92, (byte) 136, (byte) 11, (byte) 228, (byte) 179, (byte) 164, (byte) 34, (byte) 32, (byte) 234, (byte) 65, (byte) 109, (byte) 15, (byte) 47, (byte) 56, (byte) 77, (byte) 28, (byte) 124, (byte) 62, (byte) 133, (byte) 94, (byte) 56, (byte) 3, (byte) 228, (byte) 56, (byte) 149, (byte) 138, (byte) 52, (byte) 219, (byte) 227, (byte) 28, (byte) 192, (byte) 186, (byte) 44, (byte) 121, (byte) 59, (byte) 181, (byte) 103, (byte) 148, (byte) 136, (byte) 138, (byte) 25, (byte) 55, (byte) 89, (byte) 253, (byte) 193, (byte) 201, (byte) 110, (byte) 126, (byte) 167, (byte) 36, (byte) 107, (byte) 102, (byte) 221, (byte) 43, (byte) 100, (byte) 147, (byte) 240, (byte) 166, (byte) 118, (byte) 40, (byte) 95, (byte) 112, (byte) 79, (byte) 225, (byte) 117, (byte) 228, (byte) 61, (byte) 238, (byte) 127, (byte) 75, (byte) 207, (byte) 163, (byte) 44, (byte) 50, (byte) 22, (byte) 181, (byte) 240, (byte) 126, (byte) 209, (byte) 26, (byte) 220, (byte) 168, (byte) 185, (byte) 9, (byte) 55, (byte) 29, (byte) 20, (byte) 42, (byte) 158, (byte) 74, (byte) 24, (byte) 206, (byte) 65, (byte) 198, (byte) 226, (byte) 29, (byte) 44, (byte) 254, (byte) 3, (byte) 38, (byte) 68, (byte) 191, (byte) 57, (byte) 247, (byte) 15, (byte) 108, (byte) 101, (byte) 46, (byte) 91, (byte) 63, (byte) 125, (byte) 55, (byte) 16, (byte) 115, (byte) 14, (byte) 212, (byte) 208, (byte) 102, (byte) 30, (byte) 187, (byte) 112, (byte) 81, (byte) 6, (byte) 106, (byte) 91, (byte) 84, (byte) 219, (byte) 11, (byte) 125, (byte) 116, (byte) 134, (byte) 219, (byte) 206, (byte) 85, (byte) 26, (byte) 58, (byte) 87, (byte) 125, (byte) 55, (byte) 146, (byte) 64, (byte) 102, (byte) 239, (byte) 171, (byte) 49, (byte) 83, (byte) 236, (byte) 15, (byte) 239, (byte) 243, (byte) 84, (byte) 220, (byte) 25, (byte) 90, (byte) 7, (byte) 74, (byte) 48, (byte) 49, (byte) 67, (byte) 173, (byte) 132, (byte) 110, (byte) 18, (byte) 125, (byte) 57, (byte) 156, (byte) 255, (byte) 197, (byte) 55, (byte) 253, (byte) 87, (byte) 203, (byte) 35, (byte) 32, (byte) 177, (byte) 92, (byte) 230, (byte) 227, (byte) 91, (byte) 189, (byte) 185, (byte) 84, (byte) 254, (byte) 56, (byte) 107, (byte) 169, (byte) 140, (byte) 244, (byte) 9, (byte) 23, (byte) 28, (byte) 59, (byte) 80, (byte) 210, (byte) 190, (byte) 10, (byte) 6, (byte) 124, (byte) 173, (byte) 147, (byte) 65, (byte) 240, (byte) 102, (byte) 48, (byte) 73, (byte) 30, (byte) 143, (byte) 56, (byte) 2, (byte) 182, (byte) 94, (byte) 137, (byte) 100, (byte) 160, (byte) 204, (byte) 195, (byte) 94, (byte) 98, (byte) 40, (byte) 113, (byte) 22, (byte) 96, (byte) 25, (byte) 148, (byte) 71, (byte) 40, (byte) 186, (byte) 87, (byte) 29, (byte) 39, (byte) 43, (byte) 252, (byte) 107, (byte) 12, (byte) 230, (byte) 160, (byte) 70, (byte) 141, (byte) 201, (byte) 0, (byte) 212, (byte) 41, (byte) 32, (byte) 169, (byte) 130, (byte) 152, (byte) 30, (byte) 108, (byte) 231, (byte) 168, (byte) 56, (byte) 87, (byte) 209, (byte) 25, (byte) 55, (byte) 89, (byte) 208, (byte) 93, (byte) 63, (byte) 9, (byte) 35, (byte) 167, (byte) 50, (byte) 57, (byte) 92, (byte) 248, (byte) 86, (byte) 109, (byte) 163, (byte) 33, (byte) 62, (byte) 249, (byte) 70, (byte) 193, (byte) 166, (byte) 161, (byte) 180, (byte) 196, (byte) 100, (byte) 51, (byte) 236, (byte) 12, (byte) 233, (byte) 81, (byte) 178, (byte) 141, (byte) 121, (byte) 236, (byte) 142, (byte) 159, (byte) 255, (byte) 171, (byte) 133, (byte) 105, (byte) 179, (byte) 99, (byte) 234, (byte) 171, (byte) 125, (byte) 206, (byte) 101, (byte) 194, (byte) 40, (byte) 53, (byte) 36, (byte) 95, (byte) 251, (byte) 68, (byte) 104, (byte) 5, (byte) 46, (byte) 86, (byte) 75, (byte) 214, (byte) 236, (byte) 106, (byte) 221, (byte) 152, (byte) 201, (byte) 23, (byte) 99, (byte) 147, (byte) 52, (byte) 107, (byte) 19, (byte) 130, (byte) 98, (byte) 181, (byte) 80, (byte) 27, (byte) 238, (byte) 251, (byte) 29, (byte) 188, (byte) 116, (byte) 130, (byte) 156, (byte) 210, (byte) 36, (byte) 13, (byte) 75, (byte) 177, (byte) 119, (byte) 250, (byte) 247, (byte) 45, (byte) 244, (byte) 120, (byte) 29, (byte) 96, (byte) 227, (byte) 68, (byte) 139, (byte) 143, (byte) 45, (byte) 160, (byte) 248, (byte) 121, (byte) 133, (byte) 41, (byte) 164, (byte) 157, (byte) 120, (byte) 109, (byte) 113, (byte) 126, (byte) 57, (byte) 93, (byte) 130, (byte) 86, (byte) 66, (byte) 85, (byte) 137, (byte) 247, (byte) 244, (byte) 11, (byte) 46, (byte) 154, (byte) 66, (byte) 87, (byte) 134, (byte) 133, (byte) 9, (byte) 183, (byte) 137, (byte) 90, (byte) 0, (byte) 101, (byte) 197, (byte) 190, (byte) 61, (byte) 209, (byte) 226, (byte) 120, (byte) 111, (byte) 105, (byte) 196, (byte) 213, (byte) 253, (byte) 159, (byte) 162, (byte) 58, (byte) 208, (byte) 21, (byte) 78, (byte) 164, (byte) 64, (byte) 128, (byte) 252, (byte) 156, (byte) 17, (byte) 180, (byte) 232, (byte) 77, (byte) 5, (byte) 252, (byte) 250, (byte) 236, (byte) 32, (byte) 236, (byte) 203, (byte) 216, (byte) 162, (byte) 47, (byte) 185, (byte) 41, (byte) 105, (byte) 147, (byte) 8, (byte) 172, (byte) 192, (byte) 17, (byte) 44, (byte) 150, (byte) 117, (byte) 96, (byte) 134, (byte) 9, (byte) 133, (byte) 135, (byte) 163, (byte) 177, (byte) 75, (byte) 172, (byte) 136, (byte) 142, (byte) 112, (byte) 213, (byte) 62, (byte) 118, (byte) 17, (byte) 203, (byte) 158, (byte) 34, (byte) 99, (byte) 80, (byte) 123, (byte) 240, (byte) 233, (byte) 69, (byte) 201, (byte) 100, (byte) 186, (byte) 119, (byte) 94, (byte) 168, (byte) 15, (byte) 63, (byte) 97, (byte) 13, (byte) 67, (byte) 163, (byte) 224, (byte) 110, (byte) 62, (byte) 57, (byte) 193, (byte) 94, (byte) 10, (byte) 187, (byte) 188, (byte) 197, (byte) 161, (byte) 197, (byte) 81, (byte) 132, (byte) 97, (byte) 11, (byte) 172, (byte) 84, (byte) 13, (byte) 58, (byte) 233, (byte) 23, (byte) 2, (byte) 71, (byte) 183, (byte) 185, (byte) 179, (byte) 159, (byte) 174, (byte) 61, (byte) 181, (byte) 233, (byte) 91, (byte) 29, (byte) 146, (byte) 169, (byte) 131, (byte) 50, (byte) 233, (byte) 155, (byte) 198, (byte) 63, (byte) 183, (byte) 241, (byte) 101, (byte) 212, (byte) 37, (byte) 140, (byte) 148, (byte) 30, (byte) 45, (byte) 172, (byte) 156, (byte) 37, (byte) 214, (byte) 225, (byte) 249, (byte) 20, (byte) 197, (byte) 31, (byte) 165, (byte) 183, (byte) 47, (byte) 74, (byte) 114, (byte) 5, (byte) 19, (byte) 146, (byte) 45, (byte) 201, (byte) 165, (byte) 225, (byte) 255, (byte) 211, (byte) 70, (byte) 22, (byte) 52, (byte) 219, (byte) 211, (byte) 248, (byte) 80, (byte) 250, (byte) 95, (byte) 18, (byte) 65, (byte) 228, (byte) 55, (byte) 89, (byte) 239, (byte) 123, (byte) 4, (byte) 118, (byte) 142, (byte) 57, (byte) 226, (byte) 82, (byte) 59, (byte) 121, (byte) 118, (byte) 107, (byte) 89, (byte) 173, (byte) 31, (byte) 37, (byte) 94, (byte) 252, (byte) 80, (byte) 189, (byte) 16, (byte) 78, (byte) 22, (byte) 224, (byte) 118, (byte) 18, (byte) 33, (byte) 255, (byte) 130, (byte) 234, (byte) 240, (byte) 13, (byte) 254, (byte) 242, (byte) 21, (byte) 113, (byte) 136, (byte) 137, (byte) 236, (byte) 214, (byte) 65, (byte) 242, (byte) 88, (byte) 56, (byte) 90, (byte) 147, (byte) 4, (byte) 119, (byte) 177, (byte) 69, (byte) 236, (byte) 70, (byte) 238, (byte) 188, (byte) 179, (byte) 221, (byte) 254, (byte) 199, (byte) 191, (byte) 79, (byte) 40, (byte) 109, (byte) 94, (byte) 45, (byte) 95, (byte) 85, (byte) 180, (byte) 163, (byte) 10, (byte) 154, (byte) 60, (byte) 20, (byte) 192, (byte) 172, (byte) 14, (byte) 78, (byte) 165, (byte) 248, (byte) 174, (byte) 97, (byte) 253, (byte) 77, (byte) 236, (byte) 58, (byte) 252, (byte) 114, (byte) 186, (byte) 112, (byte) 150, (byte) 95, (byte) 169, (byte) 155, (byte) 100, (byte) 211, (byte) 24, (byte) 51, (byte) 51, (byte) 137, (byte) 76, (byte) 106, (byte) 32, (byte) 79, (byte) 84, (byte) 154, (byte) 149, (byte) 53, (byte) 35, (byte) 156, (byte) 123, (byte) 127, (byte) 173, (byte) 235, (byte) 186, (byte) 78, (byte) 58, (byte) 164, (byte) 182, (byte) 253, (byte) 120, (byte) 116, (byte) 55, (byte) 35, (byte) 228, (byte) 31, (byte) 244, (byte) 192, (byte) 143, (byte) 168, (byte) 167, (byte) 94, (byte) 192, (byte) 11, (byte) 162, (byte) 71, (byte) 71, (byte) 82, (byte) 212, (byte) 14, (byte) 220, (byte) 139, (byte) 243, (byte) 149, (byte) 116, (byte) 105, (byte) 163, (byte) 151, (byte) 22, (byte) 181, (byte) 117, (byte) 183, (byte) 1, (byte) 11, (byte) 125, (byte) 72, (byte) 224, (byte) 24, (byte) 248, (byte) 129, (byte) 68, (byte) 167, (byte) 160, (byte) 208, (byte) 181, (byte) 33, (byte) 237, (byte) 178, (byte) 76, (byte) 253, (byte) 117, (byte) 94, (byte) 175, (byte) 177, (byte) 108, (byte) 62, (byte) 187, (byte) 188, (byte) 69, (byte) 213, (byte) 47, (byte) 136, (byte) 27, (byte) 35, (byte) 95, (byte) 34, (byte) 252, (byte) 7, (byte) 235, (byte) 17, (byte) 88, (byte) 122, (byte) 149, (byte) 232, (byte) 176, (byte) 57, (byte) 165, (byte) 45, (byte) 148, (byte) 107, (byte) 53, (byte) 25, (byte) 228, (byte) 78, (byte) 29, (byte) 176, (byte) 26, (byte) 129, (byte) 208, (byte) 228, (byte) 97, (byte) 84, (byte) 133, (byte) 216, (byte) 39, (byte) 80, (byte) 71, (byte) 247, (byte) 23, (byte) 219, (byte) 72, (byte) 90, (byte) 111, (byte) 113, (byte) 107, (byte) 249, (byte) 95, (byte) 152, (byte) 123, (byte) 37, (byte) 191, (byte) 2, (byte) 163, (byte) 53, (byte) 222, (byte) 94, (byte) 128, (byte) 9, (byte) 0, (byte) 5, (byte) 135, (byte) 76, (byte) 66, (byte) 145, (byte) 197, (byte) 72, (byte) 71, (byte) 171, (byte) 62, (byte) 92, (byte) 18, (byte) 113, (byte) 110, (byte) 159, (byte) 138, (byte) 209, (byte) 178, (byte) 8, (byte) 47, (byte) 104, (byte) 21, (byte) 157, (byte) 237, (byte) 5, (byte) 177, (byte) 56, (byte) 209, (byte) 72, (byte) 204, (byte) 0, (byte) 3, (byte) 23, (byte) 108, (byte) 231, (byte) 98, (byte) 69, (byte) 248, (byte) 122, (byte) 106, (byte) 117, (byte) 50, (byte) 112, (byte) 76, (byte) 112, (byte) 122, (byte) 143, (byte) 215, (byte) 128, (byte) 101, (byte) 229, (byte) 0, (byte) 146, (byte) 178, (byte) 222, (byte) 40, (byte) 63, (byte) 206, (byte) 91, (byte) 204, (byte) 85, (byte) 200, (byte) 72, (byte) 125, (byte) 176, (byte) 169, (byte) 115, (byte) 195, (byte) 47, (byte) 84, (byte) 145, (byte) 52, (byte) 66, (byte) 168, (byte) 229, (byte) 108, (byte) 49, (byte) 20, (byte) 153, (byte) 181, (byte) 157, (byte) 32, (byte) 172, (byte) 210, (byte) 152, (byte) 9, (byte) 181, (byte) 201, (byte) 154, (byte) 85, (byte) 122, (byte) 251, (byte) 203, (byte) 54, (byte) 226, (byte) 57, (byte) 22, (byte) 53, (byte) 50, (byte) 100, (byte) 206, (byte) 55, (byte) 52, (byte) 0, (byte) 30, (byte) 127, (byte) 36, (byte) 50, (byte) 143, (byte) 80, (byte) 19, (byte) 254, (byte) 174, (byte) 53, (byte) 42, (byte) 12, (byte) 41, (byte) 116, (byte) 147, (byte) 220, (byte) 123, (byte) 158, (byte) 134, (byte) 189, (byte) 210, (byte) 246, (byte) 211, (byte) 255, (byte) 251, (byte) 172, (byte) 147, (byte) 240, (byte) 252, (byte) 203, (byte) 23, (byte) 72, (byte) 52, (byte) 206, (byte) 137, (byte) 104, (byte) 160, (byte) 94, (byte) 144, (byte) 78, (byte) 55, (byte) 251, (byte) 114, (byte) 188, (byte) 239, (byte) 176, (byte) 87, (byte) 63, (byte) 184, (byte) 83, (byte) 115, (byte) 113, (byte) 198, (byte) 245, (byte) 223, (byte) 238, (byte) 54, (byte) 213, (byte) 131, (byte) 236, (byte) 149, (byte) 248, (byte) 112, (byte) 98, (byte) 23, (byte) 211, (byte) 111, (byte) 184, (byte) 197, (byte) 199, (byte) 141, (byte) 178, (byte) 50, (byte) 61, (byte) 234, (byte) 208, (byte) 114, (byte) 211, (byte) 13, (byte) 17, (byte) 239, (byte) 170, (byte) 36, (byte) 139, (byte) 30, (byte) 160, (byte) 222, (byte) 61, (byte) 5, (byte) 115, (byte) 11, (byte) 81, (byte) 107, (byte) 139, (byte) 116, (byte) 234, (byte) 37, (byte) 96, (byte) 71, (byte) 242, (byte) 221, (byte) 193, (byte) 78, (byte) 17, (byte) 17, (byte) 101, (byte) 81, (byte) 73, (byte) 247, (byte) 4, (byte) 162, (byte) 151, (byte) 141, (byte) 105, (byte) 229, (byte) 197, (byte) 163, (byte) 8, (byte) 1, (byte) 183, (byte) 178, (byte) 152, (byte) 126, (byte) 149, (byte) 163, (byte) 138, (byte) 42, (byte) 120, (byte) 246, (byte) 65, (byte) 97, (byte) 80, (byte) 192, (byte) 12, (byte) 12, (byte) 208, (byte) 162, (byte) 245, (byte) 20, (byte) 219, (byte) 123, (byte) 182, (byte) 203, (byte) 39, (byte) 14, (byte) 98, (byte) 70, (byte) 246, (byte) 21, (byte) 0, (byte) 94, (byte) 219, (byte) 19, (byte) 249, (byte) 155, (byte) 235, (byte) 232, (byte) 218, (byte) 189, (byte) 223, (byte) 126, (byte) 114, (byte) 148, (byte) 131, (byte) 132, (byte) 63, (byte) 67, (byte) 111, (byte) 221, (byte) 237, (byte) 9, (byte) 176, (byte) 226, (byte) 157, (byte) 125, (byte) 241, (byte) 98, (byte) 78, (byte) 127, (byte) 29, (byte) 76, (byte) 158, (byte) 58, (byte) 76, (byte) 39, (byte) 145, (byte) 153, (byte) 22, (byte) 135, (byte) 5, (byte) 74, (byte) 199, (byte) 150, (byte) 141, (byte) 221, (byte) 25, (byte) 236, (byte) 247, (byte) 117, (byte) 217, (byte) 176, (byte) 161, (byte) 176, (byte) 29, (byte) 36, (byte) 56, (byte) 176, (byte) 188, (byte) 117, (byte) 13, (byte) 247, (byte) 132, (byte) 191, (byte) 218, (byte) 214, (byte) 169, (byte) 47, (byte) 113, (byte) 191, (byte) 121, (byte) 124, (byte) 231, (byte) 75, (byte) 135, (byte) 170, (byte) 75, (byte) 144, (byte) 238, (byte) 23, (byte) 94, (byte) 27, (byte) 133, (byte) 110, (byte) 123, (byte) 15, (byte) 37, (byte) 220, (byte) 144, (byte) 10, (byte) 172, (byte) 102, (byte) 203, (byte) 8, (byte) 198, (byte) 144, (byte) 47, (byte) 38, (byte) 238, (byte) 250, (byte) 92, (byte) 169, (byte) 12, (byte) 233, (byte) 127, (byte) 142, (byte) 106, (byte) 178, (byte) 148, (byte) 143, (byte) 73, (byte) 68, (byte) 170, (byte) 208, (byte) 160, (byte) 236, (byte) 104, (byte) 76, (byte) 173, (byte) 214, (byte) 208, (byte) 250, (byte) 106, (byte) 89, (byte) 207, (byte) 88, (byte) 211, (byte) 228, (byte) 149, (byte) 53, (byte) 237, (byte) 191, (byte) 231, (byte) 114, (byte) 75, (byte) 90, (byte) 192, (byte) 49, (byte) 161, (byte) 165, (byte) 249, (byte) 21, (byte) 186, (byte) 51, (byte) 219, (byte) 20, (byte) 27, (byte) 195, (byte) 74, (byte) 142, (byte) 166, (byte) 21, (byte) 32, (byte) 190, (byte) 129, (byte) 160, (byte) 11, (byte) 240, (byte) 125, (byte) 188, (byte) 193, (byte) 7, (byte) 173, (byte) 43, (byte) 229, (byte) 28, (byte) 26, (byte) 117, (byte) 207, (byte) 73, (byte) 30, (byte) 206, (byte) 107, (byte) 215, (byte) 232, (byte) 186, (byte) 47, (byte) 188, (byte) 203, (byte) 157, (byte) 217, (byte) 34, (byte) 160, (byte) 216, (byte) 133, (byte) 55, (byte) 182, (byte) 107, (byte) 204, (byte) 21, (byte) 95, (byte) 97, (byte) 243, (byte) 234, (byte) 7, (byte) 181, (byte) 60, (byte) 224, (byte) 211, (byte) 163, (byte) 181, (byte) 252, (byte) 0, (byte) 225, (byte) 216, (byte) 161, (byte) 200, (byte) 209, (byte) 121, (byte) 160, (byte) 51, (byte) 188, (byte) 191, (byte) 113, (byte) 51, (byte) 129, (byte) 17, (byte) 233, (byte) 205, (byte) 70, (byte) 241, (byte) 141, (byte) 131, (byte) 19, (byte) 217, (byte) 165, (byte) 104, (byte) 19, (byte) 142, (byte) 24, (byte) 170, (byte) 135, (byte) 238, (byte) 132, (byte) 144, (byte) 5, (byte) 152, (byte) 209, (byte) 146, (byte) 175, (byte) 142, (byte) 146, (byte) 144, (byte) 37, (byte) 196, (byte) 136, (byte) 172, (byte) 190, (byte) 132, (byte) 119, (byte) 199, (byte) 114, (byte) 129, (byte) 101
  };


  private static Stream<Arguments> provideTestValues() {
    return Stream.of(
      of(TEST_STRING_0.getBytes(), EXPECTED_STRING_0.getBytes(), SuffixArrayAlgorithm.LIBDIVSUFSORT),
      of(TEST_STRING_1.getBytes(), EXPECTED_STRING_1.getBytes(), SuffixArrayAlgorithm.LIBDIVSUFSORT),
      of(TEST_STRING_2.getBytes(), EXPECTED_STRING_2.getBytes(), SuffixArrayAlgorithm.LIBDIVSUFSORT),
      of(TEST_STRING_3.getBytes(), EXPECTED_STRING_3.getBytes(), SuffixArrayAlgorithm.LIBDIVSUFSORT),
      of(TEST_STRING_4.getBytes(), EXPECTED_STRING_4.getBytes(), SuffixArrayAlgorithm.LIBDIVSUFSORT),
      of(TEST_STRING_5.getBytes(), EXPECTED_STRING_5.getBytes(), SuffixArrayAlgorithm.LIBDIVSUFSORT),
      of(TEST_STRING_6.getBytes(), EXPECTED_STRING_6.getBytes(), SuffixArrayAlgorithm.LIBDIVSUFSORT),
      of(TEST_STRING_7.getBytes(), EXPECTED_STRING_7.getBytes(), SuffixArrayAlgorithm.LIBDIVSUFSORT),
      of(BYTES_LONG, BYTES_LONG_EXPECTED, SuffixArrayAlgorithm.LIBDIVSUFSORT),

      of(TEST_STRING_0.getBytes(), EXPECTED_STRING_0.getBytes(), SuffixArrayAlgorithm.SAIS),
      of(TEST_STRING_1.getBytes(), EXPECTED_STRING_1.getBytes(), SuffixArrayAlgorithm.SAIS),
      of(TEST_STRING_2.getBytes(), EXPECTED_STRING_2.getBytes(), SuffixArrayAlgorithm.SAIS),
      of(TEST_STRING_3.getBytes(), EXPECTED_STRING_3.getBytes(), SuffixArrayAlgorithm.SAIS),
      of(TEST_STRING_4.getBytes(), EXPECTED_STRING_4.getBytes(), SuffixArrayAlgorithm.SAIS),
      of(TEST_STRING_5.getBytes(), EXPECTED_STRING_5.getBytes(), SuffixArrayAlgorithm.SAIS),
      of(TEST_STRING_6.getBytes(), EXPECTED_STRING_6.getBytes(), SuffixArrayAlgorithm.SAIS),
      of(TEST_STRING_7.getBytes(), EXPECTED_STRING_7.getBytes(), SuffixArrayAlgorithm.SAIS),
      of(BYTES_LONG, BYTES_LONG_EXPECTED, SuffixArrayAlgorithm.SAIS)
    );
  }

  @ParameterizedTest
  @MethodSource("provideTestValues")
  @DisplayName("compute bwt")
  void compute_bwt(byte[] array, byte[] bytesExpected, SuffixArrayAlgorithm algorithm) {
    // do
    byte[] bwtArray = new Bwt(new BwtParameters(algorithm)).getBwt(array);

    // then
    then(new String(bwtArray)).isEqualTo(new String(bytesExpected));
  }
}
